#include "Controller.h"
#include "AsteroidsEvents.h"

namespace asteroids {

int Controller::OnInit (int argc, char *argv[]) {
	Engine::ControllerBase::OnInit (argc, argv);

	mBindings[SDLK_q] = "quit";
	
	mBindings[SDLK_v] = "+forward";
	mBindings[SDLK_h] = "+turnleft";
	mBindings[SDLK_g] = "+turnright";

	mBindings[SDLK_SPACE] = "attack";

	mBindings[SDLK_F8] = "toggleconsole";
	mBindings[SDLK_F9] = "set playerspeed 5.0";

	Engine::RegisterListener (this, EventChangeGameState);

	return 0;
}

bool Controller::OnReceiveEvent (const Engine::EventBasePtr &event) {
	if (event->mEventType == EventChangeGameState) {
		IMGUIClear();
	}
	return false;
}

}
